var Lint = require("../lint");
describe("<align, enabled>", function () {
    var fileName = "rules/align.test.ts";
    var AlignRule = Lint.Test.getRule("align");
    it("ensures that parameters in function signatures are aligned", function () {
        var options = [true, AlignRule.PARAMETERS_OPTION];
        var failureString = AlignRule.PARAMETERS_OPTION + AlignRule.FAILURE_STRING_SUFFIX;
        var createFailure = Lint.Test.createFailuresOnFile(fileName, failureString);
        var expectedFailures = [
            createFailure([2, 1], [2, 10]),
            createFailure([7, 1], [7, 10]),
            createFailure([12, 30], [12, 39]),
            createFailure([19, 28], [19, 37]),
            createFailure([26, 34], [26, 45]),
            createFailure([32, 31], [32, 39])
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, AlignRule, options);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
    it("ensures that arguments in function calls are aligned", function () {
        var options = [true, AlignRule.ARGUMENTS_OPTION];
        var failureString = AlignRule.ARGUMENTS_OPTION + AlignRule.FAILURE_STRING_SUFFIX;
        var createFailure = Lint.Test.createFailuresOnFile(fileName, failureString);
        var expectedFailures = [
            createFailure([65, 5], [65, 11]),
            createFailure([72, 9], [72, 10]),
            createFailure([83, 14], [83, 20])
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, AlignRule, options);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
    it("ensures that statements at the same nesting level are aligned", function () {
        var options = [true, AlignRule.STATEMENTS_OPTION];
        var failureString = AlignRule.STATEMENTS_OPTION + AlignRule.FAILURE_STRING_SUFFIX;
        var createFailure = Lint.Test.createFailuresOnFile(fileName, failureString);
        var expectedFailures = [
            createFailure([119, 6], [119, 16]),
            createFailure([127, 8], [127, 18])
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, AlignRule, options);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
});
