var Lint = require("../lint");
describe("<no-consecutive-blank-lines>", function () {
    var NoConsecutiveBlankLinesRule = Lint.Test.getRule("no-consecutive-blank-lines");
    var fileName = "rules/blanklines.test.ts";
    it("ensures there is at most one consecutive blank line", function () {
        var createFailure = Lint.Test.createFailuresOnFile(fileName, NoConsecutiveBlankLinesRule.FAILURE_STRING);
        var expectedFailure1 = createFailure([2, 1], [3, 1]);
        var expectedFailure2 = createFailure([9, 1], [10, 1]);
        var expectedFailure3 = createFailure([14, 1], [15, 1]);
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, NoConsecutiveBlankLinesRule);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure1);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure2);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure3);
        assert.lengthOf(actualFailures, 3);
    });
});
