var Lint = require("../lint");
describe("<no-construct>", function () {
    var fileName = "rules/noconstruct.test.ts";
    var NoConstructRule = Lint.Test.getRule("no-construct");
    var createFailure = Lint.Test.createFailuresOnFile(fileName, NoConstructRule.FAILURE_STRING);
    var actualFailures;
    before(function () {
        actualFailures = Lint.Test.applyRuleOnFile(fileName, NoConstructRule);
    });
    it("forbids access to String constructor", function () {
        var expectedFailure = createFailure([2, 13], [2, 23]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
    it("forbids access to Number constructor", function () {
        var expectedFailure = createFailure([5, 10], [5, 23]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
    it("forbids access to Boolean constructor", function () {
        var expectedFailure = createFailure([8, 10], [8, 21]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
});
