var Lint = require("../lint");
describe("<no-empty>", function () {
    var fileName = "rules/noempty.test.ts";
    var NoEmptyRule = Lint.Test.getRule("no-empty");
    var createFailure = Lint.Test.createFailuresOnFile(fileName, NoEmptyRule.FAILURE_STRING);
    var actualFailures;
    before(function () {
        actualFailures = Lint.Test.applyRuleOnFile(fileName, NoEmptyRule);
    });
    it("forbids empty conditional blocks", function () {
        var expectedFailure1 = createFailure([1, 14], [1, 16]);
        var expectedFailure2 = createFailure([2, 14], [5, 2]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure1);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure2);
    });
    it("forbids empty function blocks", function () {
        var expectedFailure = createFailure([7, 25], [9, 2]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
    it("forbids empty loop blocks", function () {
        var expectedFailure = createFailure([11, 29], [11, 32]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
    it("forbids empty constructors", function () {
        var expectedFailure = createFailure([29, 34], [30, 6]);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
    it("non empty blocks are allowed", function () {
        assert.lengthOf(actualFailures, 5);
    });
});
