var Lint = require("../lint");
describe("<no-inferrable-types>", function () {
    var Rule = Lint.Test.getRule("no-inferrable-types");
    var fileName = "rules/noinferrabletypes.test.ts";
    it("forbids explicit type declarations where easily inferrable", function () {
        var createFailure = function (start, end, type) {
            var failureString = Rule.FAILURE_STRING_FACTORY(type);
            return Lint.Test.createFailure(fileName, start, end, failureString);
        };
        var expectedFailures = [
            createFailure([2, 8], [2, 14], "number"),
            createFailure([3, 8], [3, 15], "boolean"),
            createFailure([4, 8], [4, 14], "string"),
            createFailure([7, 18], [7, 24], "number"),
            createFailure([7, 33], [7, 40], "boolean"),
            createFailure([7, 52], [7, 58], "string")
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, Rule);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
});
