var Lint = require("../lint");
describe("<no-require-imports>", function () {
    var Rule = Lint.Test.getRule("no-require-imports");
    var fileName = "rules/norequireimports.test.ts";
    it("forbids CommmonJS style imports", function () {
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, Rule);
        assert(actualFailures.length === 6, "Expected 6 failures, got " + actualFailures.length);
        var failure1 = Lint.Test.createFailuresOnFile(fileName, Rule.FAILURE_STRING)([1, 5], [1, 25]);
        var failure2 = Lint.Test.createFailuresOnFile(fileName, Rule.FAILURE_STRING)([3, 5], [3, 27]);
        var failure3 = Lint.Test.createFailuresOnFile(fileName, Rule.FAILURE_STRING)([11, 5], [11, 27]);
        var failure4 = Lint.Test.createFailuresOnFile(fileName, Rule.FAILURE_STRING)([12, 5], [12, 27]);
        var failure5 = Lint.Test.createFailuresOnFile(fileName, Rule.FAILURE_STRING)([15, 1], [15, 31]);
        var failure6 = Lint.Test.createFailuresOnFile(fileName, Rule.FAILURE_STRING)([17, 1], [17, 18]);
        Lint.Test.assertContainsFailure(actualFailures, failure1);
        Lint.Test.assertContainsFailure(actualFailures, failure2);
        Lint.Test.assertContainsFailure(actualFailures, failure3);
        Lint.Test.assertContainsFailure(actualFailures, failure4);
        Lint.Test.assertContainsFailure(actualFailures, failure5);
        Lint.Test.assertContainsFailure(actualFailures, failure6);
    });
});
