var Lint = require("../lint");
describe("<triple-equals>", function () {
    var fileName = "rules/eqeqeq.test.ts";
    var TripleEqualsRule = Lint.Test.getRule("triple-equals");
    var actualFailures;
    before(function () {
        actualFailures = Lint.Test.applyRuleOnFile(fileName, TripleEqualsRule, [true, "allow-null-check"]);
        assert.equal(actualFailures.length, 2);
    });
    it("ensures ===", function () {
        var failureString = TripleEqualsRule.EQ_FAILURE_STRING;
        var expectedFailure = Lint.Test.createFailure(fileName, [4, 33], [4, 35], failureString);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
    it("ensures !==", function () {
        var failureString = TripleEqualsRule.NEQ_FAILURE_STRING;
        var expectedFailure = Lint.Test.createFailure(fileName, [8, 21], [8, 23], failureString);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
    });
});
